<template>
  <div class="container mx-auto">
    <hot-gamelist />
    <sport-game :index-blog-i="indexBlogI"></sport-game>
    <template v-if="isShowIndexBlog3B()">
      <div>
        <h2 class="mt-10 mb-6 text-2xl font-bold">
          {{ indexBlog3title.Text }}
        </h2>
        <el-row :gutter="20" class="justify-between mb-[24px]">
          <el-col v-if="indexBlog3B.length || !indexBlog31.IsHidden" :span="14">
            <div class="rounded-lg grid-content">
              <figure class="media">
                <iframe
                  class="rounded-lg"
                  width="720"
                  height="405"
                  :src="`${videoUrl}?allow=autoplay`"
                  title="YouTube video player"
                  frameborder="0"
                  allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"
                  allowfullscreen
                >
                </iframe>
              </figure>
            </div>
          </el-col>
          <el-col v-if="!indexBlog32.IsHidden" :span="9.5">
            <div class="grid-content h-[405px] w-[456px]">
              <img
                v-lazy="indexBlog32.ImagePath"
                class="object-cover w-full h-full rounded-lg"
              />
            </div>
          </el-col>
        </el-row>
      </div>
      <card-entry
        :images="indexBlog3B"
        content-key="index_blog_content_3_"
        @handleClick="pushHyperink"
      ></card-entry>
    </template>
    <section v-if="dontMissItSection.shouldShow" class="dont-miss-it">
      <h2 class="dont-miss-it__title">{{ dontMissItSection.title.Text }}</h2>
      <ul class="dont-miss-it__list">
        <li v-for="entry in dontMissItSection.entries" :key="entry.HtmlId">
          <DontMissCard
            :title="entry.Text"
            :person-image="entry.ImagePath"
            :background-image="getDontMissContent(entry.HtmlId)?.ImagePath"
            :style="[
              entry.HtmlId.includes('5_1') ? '--dmc-color: #0D69F2;' : '',
              entry.HtmlId.includes('5_2') ? '--dmc-color: #F2B20D;' : '',
              entry.HtmlId.includes('5_3') ? '--dmc-color: #F20D0D;' : '',
              entry.HtmlId.includes('5_4') ? '--dmc-color: #1BBF00;' : '',
            ]"
            :url="entry?.HyperLink"
          >
            {{ getDontMissContent(entry.HtmlId)?.Text }}
          </DontMissCard>
        </li>
      </ul>
    </section>
  </div>
  <div
    v-if="isAppDownloadEnabled"
    class="w-full mt-10 appdownload-container h-[408px]"
  >
    <img
      v-lazy="
        getAssetImage('assets/theme/common/appdownload/bg-app-download.png')
      "
      alt=""
      class="appdownload-bg-img"
    />
    <AppDownload></AppDownload>
  </div>
</template>
<script setup lang="ts">
import _ from "lodash";
import HotGamelist from "./components/HotGameList.client.vue";
import SportGame from "./components/SportGame.client.vue";
import DontMissCard from "./components/DontMissCard.client.vue";
import AppDownload from "./app-download.client.vue";
import { store } from "~~/store";
import {
  IThemePropertiesFromApi,
  ThemePropertiesFromApiDto,
} from "~~/models/companyThemePropertiesRespone";

const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const indexBlogI = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_1"
    )
);
const indexBlog3title = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_3"
    )
);
const indexBlog31 = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_3_1"
    )
);
const indexBlog32 = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_3_2"
    )
);
const isIndexBlogIIEnabled = computed(
  (): boolean =>
    !themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_2"
    ).IsHidden
);
const isIndexBlogVEnabled = computed(
  (): boolean =>
    !themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_5"
    ).IsHidden
);
const indexBlog3B = computed(
  (): Array<IThemePropertiesFromApi> =>
    themePropertyHelper.getMultipleThemesProperties(
      themeProperties.value,
      "index_blog_3_",
      ["index_blog_3_1", "index_blog_3_2"],
      true
    )
);
const hyperlinkProperty = _.first(indexBlog3B.value)?.HyperLink;
const firstBottomIndexBlogUrl =
  hyperlinkProperty !== "" ? hyperlinkProperty : indexBlog31.value.HyperLink;
const getUrl = (url: any) => {
  let baseUrl = url;
  if (baseUrl) {
    baseUrl = baseUrl.replace("watch?v=", "embed/");
    baseUrl = baseUrl.replace("youtu.be", "youtube.com/embed/");
  }
  return baseUrl;
};
const videoUrl = ref(getUrl(firstBottomIndexBlogUrl));
const pushHyperink = (link: string) => {
  videoUrl.value = getUrl(link === "" ? indexBlog31.value.HyperLink : link);
};
const isShowIndexBlog3B = () => {
  if (indexBlog3title.value.IsHidden) return false;
  if (indexBlog31.value.IsHidden && indexBlog32.value.IsHidden) return false;
  if (!indexBlog3B.value.length) return false;
  return true;
};
const getDontMissContent = (HtmlId: string) => {
  if (!HtmlId || !HtmlId.includes("index_blog_5_")) return undefined;
  const id = HtmlId.split("index_blog_5_")[1] ?? "";
  return new ThemePropertiesFromApiDto(
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      `index_blog_content_5_${id.trim()}`
    )
  );
};
const dontMissItTitle = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_5"
    )
);
const dontMissItEntries = computed((): Array<ThemePropertiesFromApiDto> => {
  const data = themePropertyHelper.getMultipleThemesProperties(
    themeProperties.value,
    "index_blog_5_"
  );
  return data;
});
const dontMissItSection = reactive({
  shouldShow: isIndexBlogVEnabled,
  title: dontMissItTitle,
  entries: dontMissItEntries,
});
const { isAppDownloadEnabled } = useHeaderComponent();
const { getAssetImage } = commonHelper;
</script>

<style scoped>
:deep(.blog-game) {
  gap: 1.5rem;
}
.dont-miss-it {
  display: flex;
  flex-direction: column;
  gap: 24px;
}
.dont-miss-it__title {
  font-weight: 700;
  font-size: 24px;
  line-height: 28px;
  letter-spacing: 0.02em;
  color: var(--text2);
  margin-top: 2.5rem;
}
.dont-miss-it__list {
  display: flex;
  flex-direction: row;
  align-items: flex-start;
  padding: 0px;
  gap: 16px;
}
.appdownload-container {
  position: relative;
  background: var(--background5);
}
.appdownload-bg-img {
  height: 408px;
  position: absolute;
  right: 0;
  bottom: 0;
}
.app-download-container {
  position: relative;
  z-index: 1;
  height: 408px !important;
}
:deep(.app-download-container .image) {
  width: 400px !important;
  height: 360px !important;
}
:deep(.card-entry) {
  margin: 0;
}
</style>
